/*
    This file is a part of the SteamWar software.

    Copyright (C) 2021  SteamWar.de-Serverteam

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.techhider;

import io.netty.buffer.ByteBuf;

import java.util.Collections;
import java.util.Set;

public class ChunkHider14 extends ChunkHider9 {

    @Override
    protected void dataHider(PosEvaluator locationEvaluator, int obfuscationTarget, Set<Integer> obfuscate, ByteBuf in, ByteBuf out, boolean skip, boolean blockPrecise) {
        out.writeShort(in.readShort()); // Block count
        byte bitsPerBlock = in.readByte();
        out.writeByte(bitsPerBlock);

        if(bitsPerBlock < 9) {
            obfuscationTarget = ChunkHider.processPalette(obfuscationTarget, obfuscate, in, out);
            obfuscate = Collections.emptySet();
        }

        processDataArray(locationEvaluator, obfuscationTarget, obfuscate, in, out, bitsPerBlock, skip || (!blockPrecise && bitsPerBlock < 9));
    }
}
