/*
 * This file is a part of the SteamWar software.
 *
 * Copyright (C) 2020  SteamWar.de-Serverteam
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.command;

import org.bukkit.command.CommandSender;

import java.util.List;

public interface TypeMapper<T> extends AbstractTypeMapper<CommandSender, T> {
    /**
     * The CommandSender can be null!
     */
    default T map(CommandSender commandSender, String[] previousArguments, String s) {
        return map(previousArguments, s);
    }

    // For backwards compatibility, can be removed later on
    // SINCE="Use the other map Function without calling super!"
    @Deprecated
    default T map(String[] previousArguments, String s) {
        throw new SecurityException();
    }
}
