/*
    This file is a part of the SteamWar software.

    Copyright (C) 2020  SteamWar.de-Serverteam

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

package de.steamwar.core;

import com.comphenix.tinyprotocol.Reflection;
import org.bukkit.Material;
import org.bukkit.World;
import org.bukkit.entity.EntityType;
import org.bukkit.entity.Player;
import org.bukkit.inventory.ItemStack;

public class FlatteningWrapper {
    private FlatteningWrapper() {}

    public static final Class<?> scoreboardObjective = Reflection.getClass("{nms.network.protocol.game}.PacketPlayOutScoreboardObjective");
    public static final Class<?> scoreboardScore = Reflection.getClass("{nms.network.protocol.game}.PacketPlayOutScoreboardScore");

    public static final IFlatteningWrapper impl = VersionDependent.getVersionImpl(Core.getInstance());

    public interface IFlatteningWrapper {
        void setScoreboardTitle(Object packet, String title);
        void setScoreAction(Object packet);

        Material getMaterial(String material);
        Material getDye(int colorCode);
        ItemStack setSkullOwner(String player);

        Object getPose(EntityPose pose);
        void setNamedSpawnPacketDataWatcher(Object packet);
        Object formatDisplayName(String displayName);

        void setSpawnPacketType(Object packet, EntityType type);

        int getViewDistance(Player player);

        void syncSave(World world);
    }

    public enum EntityPose {
        NORMAL,
        SNEAKING,
        SWIMMING;
    }
}
