package de.steamwar.core;

import com.sk89q.worldedit.bukkit.WorldEditPlugin;
import com.sk89q.worldedit.extent.clipboard.Clipboard;
import org.bukkit.Bukkit;
import org.bukkit.entity.Player;

import java.io.IOException;
import java.io.InputStream;

public class WorldEditWrapper {
    private WorldEditWrapper() {}

    public static final IWorldEditWrapper impl = VersionDependent.getVersionImpl(Core.getInstance());

    public interface IWorldEditWrapper {
        InputStream getPlayerClipboard(Player player, boolean schemFormat);
        void setPlayerClipboard(Player player, InputStream is, boolean schemFormat);
        Clipboard getClipboard(InputStream is, boolean schemFormat) throws IOException;
    }

    public static WorldEditPlugin getWorldEditPlugin() {
        return (WorldEditPlugin) Bukkit.getPluginManager().getPlugin("WorldEdit");
    }
}
