/*
    This file is a part of the SteamWar software.

    Copyright (C) 2020  SteamWar.de-Serverteam

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

package de.steamwar.providers;

import de.steamwar.sql.SteamwarUser;
import org.bukkit.Bukkit;

import java.util.UUID;

public class BauServerInfo {
    private static Integer bauOwner = null;

    static {
        try {
            bauOwner = Integer.parseInt(Bukkit.getWorlds().get(0).getName());
        } catch (NumberFormatException e) {
            try {
                bauOwner = SteamwarUser.get(UUID.fromString(Bukkit.getWorlds().get(0).getName())).getId();
            } catch (IllegalArgumentException ignored) {}
        }
    }

    public static Integer getOwnerId() {
        return bauOwner;
    }

    public static boolean isBauServer() {
        return bauOwner != null;
    }
}
